%define name krb5-fermi-config
%define path /usr/krb5
%define version 4.6
%define release 1

Summary: Configuration scripts make your Kerberos Installation Fermilab-compatible
Name: %{name} 
Version: %{version}
Release: %{release}
Source0: %{name}-%{version}.tar.gz
License: MIT, freely distributable.
URL: http://web.mit.edu/kerberos/www/
Requires: fileutils krb5-workstation
Group: Fermi
BuildArchitectures: noarch
Packager: Troy Dawson <dawson@fnal.gov>
BuildRoot: %{_tmppath}/%{name}-%{version}
Obsoletes: %{name} < %{version}-%{release}
Conflicts: krb5-fermi-krb5.conf

%description
Kerberos V5 is a trusted-third-party network authentication system,
which can improve your network's security by eliminating the insecure
practice of cleartext passwords.
The config set's up config files so that a machine is ready to
be in Fermilab's kerberos realm

%prep
%setup
rm -rf $RPM_BUILD_ROOT

%install
install -m 0755 -d $RPM_BUILD_ROOT/etc
install -m 0755 -d $RPM_BUILD_ROOT/etc/sysconfig
install -m 0755 -d $RPM_BUILD_ROOT/%{path}/config
install -m 0755 -d $RPM_BUILD_ROOT/%{path}/man
install -m 0755 -d $RPM_BUILD_ROOT/%{path}/man/man5

install -m 0744 config-krb5.conf.aklog $RPM_BUILD_ROOT/%{path}/config/config-krb5.conf.aklog
install -m 0744 config-krb5.conf $RPM_BUILD_ROOT/%{path}/config/config-krb5.conf
install -m 0744 config-inetd.conf $RPM_BUILD_ROOT/%{path}/config/config-inetd.conf
install -m 0744 config-xinetd $RPM_BUILD_ROOT/%{path}/config/config-xinetd
install -m 0744 config-services $RPM_BUILD_ROOT/%{path}/config/config-services
install -m 0744 config-sshd_config $RPM_BUILD_ROOT/%{path}/config/config-sshd_config
install -m 0744 config-hostkeys $RPM_BUILD_ROOT/%{path}/config/config-hostkeys
install -m 0755 config-hostkeys $RPM_BUILD_ROOT/%{path}/config/makehostkeys
install -m 0755 make-cron-keytab $RPM_BUILD_ROOT/%{path}/config/make-cron-keytab
install -m 0644 inetd.conf.template $RPM_BUILD_ROOT/%{path}/config/inetd.conf.template
install -m 0644 inetd.conf.wrapped.template $RPM_BUILD_ROOT/%{path}/config/inetd.conf.wrapped.template
install -m 0644 krb5.conf.template $RPM_BUILD_ROOT/%{path}/config/krb5.conf.template
install -m 0644 services.template $RPM_BUILD_ROOT/%{path}/config/services.template
install -m 0644 sshd_config.template $RPM_BUILD_ROOT/%{path}/config/sshd_config.template
install -m 0644 sshd_config.weak.template $RPM_BUILD_ROOT/%{path}/config/sshd_config.weak.template
install -m 0644 xinetd.template $RPM_BUILD_ROOT/%{path}/config/xinetd.template
install -m 0644 ftp.xinetd $RPM_BUILD_ROOT/%{path}/config/ftp.xinetd
install -m 0644 telnet.xinetd $RPM_BUILD_ROOT/%{path}/config/telnet.xinetd
install -m 0644 klogin.xinetd $RPM_BUILD_ROOT/%{path}/config/klogin.xinetd
install -m 0644 eklogin.xinetd $RPM_BUILD_ROOT/%{path}/config/eklogin.xinetd
install -m 0644 kshell.xinetd $RPM_BUILD_ROOT/%{path}/config/kshell.xinetd
install -m 0644 gssftp.xinetd $RPM_BUILD_ROOT/%{path}/config/gssftp.xinetd
install -m 0644 ekrb5-telnet.xinetd $RPM_BUILD_ROOT/%{path}/config/ekrb5-telnet.xinetd
install -m 0644 ftp.xinetd.on $RPM_BUILD_ROOT/%{path}/config/ftp.xinetd.on
install -m 0644 telnet.xinetd.on $RPM_BUILD_ROOT/%{path}/config/telnet.xinetd.on
install -m 0644 klogin.xinetd.on $RPM_BUILD_ROOT/%{path}/config/klogin.xinetd.on
install -m 0644 eklogin.xinetd.on $RPM_BUILD_ROOT/%{path}/config/eklogin.xinetd.on
install -m 0644 kshell.xinetd.on $RPM_BUILD_ROOT/%{path}/config/kshell.xinetd.on
install -m 0644 gssftp.xinetd.on $RPM_BUILD_ROOT/%{path}/config/gssftp.xinetd.on
install -m 0644 ekrb5-telnet.xinetd.on $RPM_BUILD_ROOT/%{path}/config/ekrb5-telnet.xinetd.on
install -m 0644 krb.conf $RPM_BUILD_ROOT/etc/krb.conf.fermi
install -m 0644 krb5.conf.aklog $RPM_BUILD_ROOT/etc/sysconfig/krb5.conf.aklog

install -m 0644 man/keytab-convert.5 $RPM_BUILD_ROOT/%{path}/man/man5/keytab-convert.5
install -m 0644 man/krb5conf.5 $RPM_BUILD_ROOT/%{path}/man/man5/krb5conf.5

%post 
if [ -f /etc/krb5.conf ] ; then
	echo "We need a fresh krb5.conf, moving old krb5.conf to /etc/krb5.conf.save.%{name}.%{version}.%{release}"
	mv /etc/krb5.conf /etc/krb5.conf.save.%{name}.%{version}.%{release}
fi
%{path}/config/config-krb5.conf %{version}
if [ -f /etc/krb.conf ] ; then
	echo "Fixing /etc/krb.conf"
	if ! [ -s /etc/krb.conf.save.%{name}.%{version}.%{release} ] ; then
		mv -f /etc/krb.conf /etc/krb.conf.save.%{name}.%{version}.%{release}
	fi
	cp -f /etc/krb.conf.fermi /etc/krb.conf
fi
if [ -f /etc/inetd.conf ] ; then
	%{path}/config/config-inetd.conf %{version}
fi
if [ -d /etc/xinetd.d ] ; then
	if [ -e /etc/xinetd.d/ekrb5-telnet ] ; then
		# SLF 5.x or later, server options changed so switch files
		mv  %{path}/config/ftp.xinetd  %{path}/config/old-ftp.xinetd
		mv  %{path}/config/ftp.xinetd.on  %{path}/config/old-ftp.xinetd.on
		mv  %{path}/config/telnet.xinetd  %{path}/config/old-telnet.xinetd
		mv  %{path}/config/telnet.xinetd.on  %{path}/config/old-telnet.xinetd.on
		mv  %{path}/config/gssftp.xinetd  %{path}/config/ftp.xinetd
		mv  %{path}/config/gssftp.xinetd.on  %{path}/config/ftp.xinetd.on
		mv  %{path}/config/ekrb5-telnet.xinetd  %{path}/config/telnet.xinetd
		mv  %{path}/config/ekrb5-telnet.xinetd.on  %{path}/config/telnet.xinetd.on
	fi
	%{path}/config/config-xinetd %{version}
fi
%{path}/config/config-services %{version}
if [ -f /etc/sshd_conf ] ; then
	%{path}/config/config-sshd_config %{version}
fi
echo "Your computer is now configured to run Ierberos"
echo "If you need a host principal you should run '%{path}/config/makehostkeys'"

%preun
if [ "$1" = "0" ] ; then
	echo "We are in the pre-un and running"
fi

%triggerin -- krb5-workstation
if [ -d /etc/xinetd.d ] ; then
	%{path}/config/config-xinetd %{version} >> /tmp/fermi.krb5.config.xinetd
fi

%triggerin -- openafs, openafs-thiscell
%{path}/config/config-krb5.conf.aklog

%triggerpostun -- openafs, openafs-thiscell
%{path}/config/config-krb5.conf.aklog

%triggerin -- krbafs
if [ -f /etc/krb.conf ] ; then
	if ! [ -s /etc/krb.conf.save.%{name}.%{version}.%{release} ] ; then
		mv -f /etc/krb.conf /etc/krb.conf.save.%{name}.%{version}.%{release}
	fi
	cp -f /etc/krb.conf.fermi /etc/krb.conf
fi

%triggerin -- krb5-libs
if [ -f /etc/krb5.conf ] ; then
	grep -q 'EXAMPLE' /etc/krb5.conf
	if [ "$?" -eq 0 ] ; then
		echo "Your krb5.conf is the original version from RedHat"
		echo " ... moving krb5.conf out of the way and putting in Fermilabs"
		/bin/mv -f /etc/krb5.conf /etc/krb5.conf.save.%{name}.%{version}.%{release}
		%{path}/config/config-krb5.conf %{version}
	fi
fi

%triggerpostun -- krb5-workstation
if [ -d /etc/xinetd.d ] ; then
	%{path}/config/config-xinetd %{version} >> /tmp/fermi.krb5.config.xinetd
fi


%files
%attr(0755,root,root)  %dir %{path}
%attr(0755,root,root)  %dir %{path}/config
%attr(0755,root,root)  %dir %{path}/man
%attr(0755,root,root)  %dir %{path}/man/man5

%attr(0744,root,root)  %{path}/config/config-krb5.conf
%attr(0744,root,root)  %{path}/config/config-krb5.conf.aklog
%attr(0744,root,root)  %{path}/config/config-inetd.conf
%attr(0744,root,root)  %{path}/config/config-xinetd
%attr(0744,root,root)  %{path}/config/config-services
%attr(0744,root,root)  %{path}/config/config-sshd_config
%attr(0744,root,root)  %{path}/config/config-hostkeys
%attr(0755,root,root)  %{path}/config/makehostkeys
%attr(0755,root,root)  %{path}/config/make-cron-keytab
%attr(0644,root,root)  %{path}/config/inetd.conf.template
%attr(0644,root,root)  %{path}/config/inetd.conf.wrapped.template
%attr(0644,root,root)  %{path}/config/krb5.conf.template
%attr(0644,root,root)  %{path}/config/services.template
%attr(0644,root,root)  %{path}/config/sshd_config.template
%attr(0644,root,root)  %{path}/config/sshd_config.weak.template
%attr(0644,root,root)  %{path}/config/xinetd.template
%attr(0644,root,root)  %{path}/config/ftp.xinetd
%attr(0644,root,root)  %{path}/config/telnet.xinetd
%attr(0644,root,root)  %{path}/config/klogin.xinetd
%attr(0644,root,root)  %{path}/config/eklogin.xinetd
%attr(0644,root,root)  %{path}/config/kshell.xinetd
%attr(0644,root,root)  %{path}/config/gssftp.xinetd
%attr(0644,root,root)  %{path}/config/ekrb5-telnet.xinetd
%attr(0644,root,root)  %{path}/config/ftp.xinetd.on
%attr(0644,root,root)  %{path}/config/telnet.xinetd.on
%attr(0644,root,root)  %{path}/config/klogin.xinetd.on
%attr(0644,root,root)  %{path}/config/eklogin.xinetd.on
%attr(0644,root,root)  %{path}/config/kshell.xinetd.on
%attr(0644,root,root)  %{path}/config/gssftp.xinetd.on
%attr(0644,root,root)  %{path}/config/ekrb5-telnet.xinetd.on

%attr(0644,root,root) %{path}/man/man5/keytab-convert.5
%attr(0644,root,root) %{path}/man/man5/krb5conf.5

%attr(0644,root,root)  /etc/krb.conf.fermi
%attr(0644,root,root)  %config(noreplace) /etc/sysconfig/krb5.conf.aklog

%changelog
* Fri Jan 4 2013 Frank Nagy <nagy@fnal.gov> 4.6-1
- Update krb5.conf to v4.6 updating list of Accelerator Division servers
- Fixed bug in make-cron-keytab so it will take error exit if run
- in shared account via ksu rather than ssh into the account.

* Mon Oct 1 2012 Frank Nagy <nagy@fnal.gov> 4.5-2
- Update version number in config-krb5.conf script

* Mon Oct 1 2012 Frank Nagy <nagy@fnal.gov> 4.5-1
- Added Nova Far Detector KDC to search list, edit and re-format
- SysAdmin HowTo instructions for a local KDC search list and
- set so krb5-fermi-config and krb5-fermi-krb5.conf conflict with
- each other so only one gets installed

* Wed Feb 09 2012 Frank Nagy <nagy@fnal.gov> 4.4-2
- Correctted version number in config-krb5.conf

* Wed Feb 08 2012 Frank Nagy <nagy@fnal.gov> 4.4-1
- Correct spellings and phrasing in this file, config-xinetd and
- config-services.  Fixed order of paramter statements in the
- [capaths] section of v4.4 of krb5.conf

* Thu Oct 20 2011 Frank Nagy <nagy@fnal.gov> 4.3-1
- V4.2 added PSC.EDU and EXTENCI.ORG realms to the [realms] section
- and V4.3 changed the KDC defintions for the CERN.CN realm

* Tue Jun 28 2011 Frank Nagy <nagy@fnal.gov> 4.1-2
- Fixed typo in KDC saerch names (d0online)

* Tue Jun 07 2011 Frank Nagy <nagy@fnal.gov> 4.1-1
- Added permitted_enctypes line to [libdefaults] section
- Removed obsolete AD nodes from [domain_realms]

* Mon May 31 2011 Frank Nagy <nagy@fnal.gov> 4.0-1
- Changed to krb5.conf V4.0 with expanded KDC list, removed
- Kerberos4 ticket generation from login/pam sections and
- other minor changes.

* Mon Dec 27 2010 Troy Dawson <dawson@fnal.gov> 3.1-3
- Changed Copyrite to License in spec file
- Changed PreReq to Requires in spec file

* Thu Sep 16 2010 Frank Nagy <nagy@fnal.gov> 3.1-2
- Remove iginore_afs = true line from pam section

* Thu Sep 16 2010 Frank Nagy <nagy@fnal.gov> 3.1-1
- Emergency fix due to PAM mishandling comments on lines
- in [appdefults]pam section causing long login times

* Fri Aug 20 2010 Frank Nagy <nagy@fnal.gov> 3.0-4
- Correct some errors in krb5.conf and the config-krb5.conf scipt to
- get the editted comments correct during installation

* Fri Aug 20 2010 Frank Nagy <nagy@fnal.gov> 3.0-3
- Correct some minor errors in the krb5.conf in the package

* Fri Aug 20 2010 Frank Nagy <nagy@fnal.gov> 3.0-2
- Correct missing KDC_LOCAL_FILE definitiions in config-krb5.conf script

* Thu Aug 19 2010 Frank Nagy <nagy@fnal.gov> 3.0-1
- Installation scripts modified to drop obsolete edits and support
- local saved FNAL.GOV KDC list
- Added 3DEC to default encoding types and allow Wek Encryption in
- [libdefaults] addded commented tag linges around FNAL.GOV KDC list

* Fri Feb 19 2010 Frank Nagy <nagy@fnal.gov> 2.14-1
- Added mappings for Windows file servers to [domain_realm] section

* Wed Jan 06 2010 Frank Nagy <nagy@fnal.gov> 2.13-1
- Added entries to [domain_realm] section of krb5.conf for AD

* Thu Oct 15 2009 Frank Nagy <nagy@fnal.gov> 2.12-7
- If /etc/xinetd.d/ekrb5-telnet file found, replace the ftp and telnet
- template files in config/ (both .xinetd and .xinetd.on files) with
- the gssftp and ekrb-telnet (encrypted telnet only) templates with
- modern server options

* Wed Oct 7 2009 Frank Nagy <nagy@fnal.gov> 2.12-6
- Changed to require krb5-workstation instread of krb5-workstation-fermi and to
- obsolete previous versions of this RPM so file replacements will work correctly

* Thu Sep 10 2009 Frank Nagy <nagy@fnal.gov> 2.12-4
- Added make-cron-keytab script and fixed makehostkeys permissions
- Duplicated following changes by Troy Dawson from 12.2-1 RPM for SLF5
- Added the triggerin for krb5-libs, updating krb5.conf if EXAMPLE is in the file

* Mon Jul 13 2009 Frank Nagy <nagy@fnal.gov> 2.12-4
- Release 3 did not work so use %attr in the %files section

* Mon Jul 13 2009 Frank Nagy <nagy@fnal.gov> 2.12-3
- Explicitly set file owner on install command

* Fri Jul 10 2009 Frank Nagy <nagy@fnal.gov> 2.12-2
- Corrected file owner in tarball to root:root

* Wed Jul 8 2009 Frank Nagy <nagy@fnal.gov> 2.12-1
- Updated to V 2.12 of krb5.conf; added FERMITEST domain definitions and mappings

* Mon Jun 8 2009 Frank Nagy <nagy@fnal.gov) 2.11-1
- Updated to version 2.11 of krb5.conf

* Fri Jun 27 2008 Troy Dawson <dawson@fnal.gov> 2.8-1
- Updated to version 2.8
- kept the ignore_afs change

* Thu Oct 25 2007 Troy Dawson <dawson@fnal.gov> 2.7a-1
- Removed the "ignore_afs = true" from the pam section

* Mon Aug 27 2007 Troy Dawson <dawson@fnal.gov> 2.7.1
- Updated to krb5.conf 2.7 - fixing cryptocard problems

* Mon Aug 08 2007 Troy Dawson <dawson@fnal.gov> 2.5-4
- Made it generic, to work with both SLF3 and SLF4

* Mon Aug 08 2007 Troy Dawson <dawson@fnal.gov> 2.5-3
- Updated the name to match the krb5.conf version - 2.5
- updated the config script to say 2.5
- Made it so that it moves the old krb5.conf out of the way

* Mon Jul 02 2007 Troy Dawson <dawson@fnal.gov> 1.25-1.LTS4
- updated the krb5.conf.template file to version 1.25
- Changed makekeys so that it finds the right kadmin

* Wed Jun 27 2007 Troy Dawson <dawson@fnal.gov> 1.24a-1.LTS4
- updated the krb5.conf.template file to version 1.24a

* Tue Oct 03 2006 Troy Dawson <dawson@fnal.gov> 1.16-1.LTS4
- updated the krb5.conf.template file to version 1.16

* Thu Aug 31 2006 Troy Dawson <dawson@fnal.gov> 1.15-1.LTS4
- updated the krb5.conf.template file to version 1.15

* Fri Aug 05 2005 Troy Dawson <dawson@fnal.gov> 1.10-1.LTS4
- updated the krb5.conf.template file to version 1.10

* Tue Nov 02 2004 Troy Dawson <dawson@fnal.gov> 1.9-4.LTS
- added config-krb5.conf.aklog and /etc/sysconfig/krb5.conf.aklog
- added triggers to run config-krb5.conf.aklog with AFS triggers

* Fri Oct 01 2004 Troy Dawson <dawson@fnal.gov> 1.9-3.LTS
- fixed script that says it's 1.8a
- made the rpm a noarch

* Wed Sep 28 2004 Troy Dawson <dawson@fnal.gov> 1.9-1.LTS
- updated to 1.9

* Tue Apr 06 2004 Troy Dawson <dawson@fnal.gov>
- added .sdsc.edu to the FNAL.GOV realm

* Tue Apr 06 2004 Troy Dawson <dawson@fnal.gov>
- added .sdsc.edu to the FNAL.GOV realm

* Fri Apr 02 2004 Troy Dawson <dawson@fnal.gov>
- Changed krb5.conf.template to put PAM section at top.

* Mon Feb 09 2004 Troy Dawson <dawson@fnal.gov>
- Fixed it so that it no longer moves the current krb5.conf out of the way
if it does not have to.

* Fri Jan 16 2004 Troy Dawson <dawson@fnal.gov>
- Updated to krb5conf 1.8a

* Tue Nov 11 2003 Troy Dawson <dawson@fnal.gov>
- Put back in the krb.conf, but with proper settings, and triggers

* Tue Oct 04 2003 Troy Dawson <dawson@fnal.gov>
- Cleaned out krb.conf so it quits messing things up.

* Tue Oct 04 2003 Troy Dawson <dawson@fnal.gov>
- Converted to krb5conf 1.7.  I had missed a few things the first time

* Thu Sep 25 2003 Troy Dawson <dawson@fnal.gov>
- Added triggers for the xinetd configs

* Mon Apr 07 2003 Troy Dawson <dawson@fnal.gov>
- Took out the check that took krb.conf completely out.

* Wed Apr 02 2003 Troy Dawson <dawson@fnal.gov>
- Took /etc/krb.conf out

* Fri Aug 09 2002 Troy Dawson <dawson@fnal.gov>
- Changed the requires, put in a check before it does ssh config

* Fri May 24 2002 Troy Dawson <dawson@fnal.gov>
- Fixed a bug in the krb5.conf template (removed two 4's)

* Tue May 07 2002 Troy Dawson <dawson@fnal.gov>
- Made changes to the config xinetd script

* Mon May 06 2002 Troy Dawson <dawson@fnal.gov>
- Configured to use the krb5conf v1_6 stuff

* Thu Oct 25 2001 Troy Dawson <dawson@fnal.gov>
- Changed spec file so that it moves the /etc/krb5.conf file

* Thu Oct 25 2001 Troy Dawson <dawson@fnal.gov>
- Changed the krb5.conf.template file so that the Pam part was first, 
also lengthened ticket time
- Edited the spec file so that it doesn't automatically move the /etc/krb5.conf file

* Tue Oct 2 2001 Troy Dawson <dawson@fnal.gov>
- Made changes for pam usage in krb.conf and krb5.conf
- Also removed the linking of /usr/krb5 and /usr/kerberos

* Mon Aug 27 2001 Troy Dawson <dawson@fnal.gov>
- Upgraded from krb5conf 1.5.  Also put in changes for xinetd.

* Tue Jun 12 2001 Troy Dawson <dawson@fnal.gov>
- Made improvements to the makehostkeys script.  I also have it check 
  for the varias files (sshd_config, services) before modifying them.

* Tue Jun 5 2001 Troy Dawson <dawson@fnal.gov>
- The config-inetd.conf script has been changed to look for services
  that have a kerberos equal.  If these services were originally turned
  off, then the kerberized version is turned off.  I also took out the
  keytab-convert program, as this is dependant on one particular flavor
  of fermi kerberos.

* Tue May 22 2001 Troy Dawson <dawson@fnal.gov>
- I added the keytab-convert program into the config rpm, with it's
  corresponding manpage.  It will also be in the normal kerberos rpm
  but in the bin area.

* Mon May 21 2001 Troy Dawson <dawson@fnal.gov>
- I changed things to the version 1.4.  I also added the config-sshd_config
  script, as well as the config-hostkeys script.

* Wed May 9 2001 Troy Dawson <dawson@fnal.gov>
- I finished with the config-services and config-inetd.conf scripts.
  I also changed how the /usr/krb5 and /usr/kerberos were linked.

* Wed May 2 2001 Troy Dawson <dawson@fnal.gov>
- I put the raw scripts into the package from Fermi.  These will
  need to be rewritten so that they don't depend on Fermi packages.

